searchData={"items":[{"type":"module","title":"BuildDotZig.Compiler","doc":"","ref":"BuildDotZig.Compiler.html"},{"type":"function","title":"BuildDotZig.Compiler.build/1","doc":"","ref":"BuildDotZig.Compiler.html#build/1"},{"type":"function","title":"BuildDotZig.Compiler.clean/0","doc":"","ref":"BuildDotZig.Compiler.html#clean/0"},{"type":"function","title":"BuildDotZig.Compiler.compile/0","doc":"","ref":"BuildDotZig.Compiler.html#compile/0"},{"type":"task","title":"mix build_dot_zig.gen.c_nif","doc":"Initializes a C NIF with its build system based on `build.zig`.\n\n    mix build_dot_zig.gen.c_nif Math math sum/2 multiply/2\n\nThe first argument is the Elixir module that will expose the NIF, relative to the base namespace\nof your app. In this case the generated module will be in `lib/your_app/math.ex` and will be\ncalled `YourApp.Math`.\n\nThe second argument is the name of the NIF library. In this case the generated C file will be\n`src/math.c`.\n\nThe other arguments represent the functions exposed by the NIF with their arity. Empty stubs\nfor each of the listed functions will be generated both on the Elixir and C side. By default\nthe function stubs just raise a `:not_implemented` error.","ref":"Mix.Tasks.BuildDotZig.Gen.CNif.html"},{"type":"task","title":"Functions - mix build_dot_zig.gen.c_nif","doc":"The functions are given using `name/arity` syntax.\n\nIt's possible to pass the same function with multiple arities (e.g. `sum/2`, `sum/3`), in\nthat case on the C side there will still be only a single function and its implementation\nwill have to distinguish between the different arities at runtime by looking at `argc`.","ref":"Mix.Tasks.BuildDotZig.Gen.CNif.html#module-functions"},{"type":"task","title":"mix compile.build_dot_zig","doc":"Runs `zig build` using the `build.zig` file in the current project.\n\nThis task runs `zig build` in the current project; any output coming from `zig build` is printed\nin real-time on stdout.","ref":"Mix.Tasks.Compile.BuildDotZig.html"},{"type":"task","title":"Configuration - mix compile.build_dot_zig","doc":"This compiler can be configured through the return value of the `project/0` function in\n`mix.exs`; for example:\n\n    def project() do\n      [\n        app: :myapp,\n        compilers: [:build_dot_zig] ++ Mix.compilers,\n        deps: deps()\n      ]\n    end\n\nThe following options are available:\n\n  * `:install_zig` - (binary or boolean) determines if a Zig installation should be automatically\n  downloaded and installed locally in the build directory. If `false`, no Zig installation is\n  downloaded. If `true` (default), the latest Zig stable version is downloaded. Otherwise, it's\n  possible to pass a specific Zig version, e.g. `install_zig: \"0.11.0\"`.\n\n  >","ref":"Mix.Tasks.Compile.BuildDotZig.html#module-configuration"},{"type":"task","title":"Zig version support {: .warning } - mix compile.build_dot_zig","doc":">\n  > `:build_dot_zig` currently supports only Zig version `0.11.0` due to breaking changes\n  > to the build options passed in the command line. As long as the command line interface\n  > remains stable, it will be possible to support multiple future Zig versions.\n\n  * `:zig_executable` - (binary or `:default`) it's the executable to use as the `zig`\n  program. If not provided or if `:default`, it defaults to the downloaded `zig` binary if\n  the `install_zig` was configured to download Zig, otherwise it defaults to `zig` (it assumes\n  to find it in the `PATH`). Note that it's possible to both install a downloaded Zig installation\n  _and_ pass a local `:zig_executable`. This is useful for use cases where the downloaded Zig\n  installation must be called through some wrapper script.\n\n  * `:zig_build_mode` - (atom) allows choosing the build mode. The supported build modes are\n  `:debug`, `:release_safe`, `:release_fast` and `:release_small`. By default the build mode\n  is `:release_safe` when `Mix.env()` is `:prod` and `:debug` in all other cases.\n\n  * `:zig_target` - (binary or `:host`) it's the target that will be passed with the\n  `-Dtarget` flag to `zig`. This can be used to support cross-compilation. If not provided or if\n  `:host` (which is the default returned by `Mix.target()`), the `-Dtarget` flag is not passed.\n\n  * `:zig_cpu` - (binary or `:native`) the set of CPU features that will be passed with the\n  `-Dcpu` flag to `zig`. If not provided or if `:native` the `-Dcpu` flag is not passed, which\n  makes `zig` use _all_ the CPU features of the host. If you're not running the compiled code on\n  the same machine where you're compiling, setting this to `\"baseline\"` is a good starting point.\n\n  * `:zig_extra_options` - (keyword list) if you define additional options in your `build.zig`\n  using `b.option()`, you can pass the values of those options here (e.g.\n  `[some_option: \"some_value\"]`).","ref":"Mix.Tasks.Compile.BuildDotZig.html#module-zig-version-support-warning"},{"type":"task","title":"Default environment variables - mix compile.build_dot_zig","doc":"This compiler also sets deveral default environment variables which are accessible\nfrom `build.zig`:\n\n* `MIX_TARGET`\n* `MIX_ENV`\n* `MIX_BUILD_PATH` - same as `Mix.Project.build_path/0`\n* `MIX_APP_PATH` - same as `Mix.Project.app_path/0`\n* `MIX_COMPILE_PATH` - same as `Mix.Project.compile_path/0`\n* `MIX_CONSOLIDATION_PATH` - same as `Mix.Project.consolidation_path/0`\n* `MIX_DEPS_PATH` - same as `Mix.Project.deps_path/0`\n* `MIX_MANIFEST_PATH` - same as `Mix.Project.manifest_path/0`\n* `ERL_EI_LIBDIR`\n* `ERL_EI_INCLUDE_DIR`\n* `ERTS_INCLUDE_DIR`\n* `ERL_INTERFACE_LIB_DIR`\n* `ERL_INTERFACE_INCLUDE_DIR`\n* `ZIG_INSTALL_DIR` - the directory where the Zig toolchain was downloaded, if it was.","ref":"Mix.Tasks.Compile.BuildDotZig.html#module-default-environment-variables"},{"type":"task","title":"Compilation artifacts and working with priv directories - mix compile.build_dot_zig","doc":"Generally speaking, compilation artifacts are written to the `priv` directory, as that the only\ndirectory, besides `ebin`, which are available to Erlang/OTP applications.\n\nHowever, note that Mix projects supports the `:build_embedded` configuration, which controls if\nassets in the `_build` directory are symlinked (when `false`, the default) or copied (`true`).\nIn order to support both options for `:build_embedded`, it is important to follow the given\nguidelines:\n\n* The `\"priv\"` directory must not exist in the source code\n* If there are static assets, `build.zig` should copy them over from a directory at the project\nroot (not named \"priv\")\n\nThis compiler passes `$MIX_APP_PATH/priv/$MIX_TARGET` as install prefix to `zig build`, so the\nresulting artifacts can be found in `$PREFIX/lib` for libraries and `$PREFIX/bin` for binaries.\nNote that the default `$MIX_TARGET` is `:host`.","ref":"Mix.Tasks.Compile.BuildDotZig.html#module-compilation-artifacts-and-working-with-priv-directories"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),\nand this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).\n\n## [0.5.0] - 2024-07-26\n\n- Bump default Zig version to `0.13.0` and make the generated `build.zig` compatible with it.\n\n## [0.4.2] - 2023-12-13","ref":"changelog.html"},{"type":"extras","title":"Fixed - Changelog","doc":"- Add missing include in generated library to make it work on Windows\n\n## [0.4.1] - 2023-12-13","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- Fix the generated `build.zig` to make it work on Windows.\n\n## [0.4.0] - 2023-12-11","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- Add `mix build_dot_zig.gen.c_nif` Mix generator.\n- Allow passing project-specific options with `zig_extra_options`.","ref":"changelog.html#added"},{"type":"extras","title":"Changed - Changelog","doc":"- Use `:release_safe` build mode by default in `:prod` env. Leave `:debug` as default in all other\n  cases.","ref":"changelog.html#changed"},{"type":"extras","title":"Fixed - Changelog","doc":"- Fix arch detection on Windows.\n\n## [0.3.1] - 2023-08-22","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- Pass the correct option for optimize modes.","ref":"changelog.html#fixed"},{"type":"extras","title":"Changed - Changelog","doc":"- Due to the different options for the optimize modes, `:build_dot_zig` is currently only\ncompatible with Zig version `0.11.0`.\n\n## [0.3.0] - 2023-08-08","ref":"changelog.html#changed"},{"type":"extras","title":"Added - Changelog","doc":"- Add `zig_target` option.\n- Add `zig_cpu` option.","ref":"changelog.html#added"},{"type":"extras","title":"Changed - Changelog","doc":"- Bump latest stable `zig` to `0.11.0`.\n\n## [0.2.0] - 2023-07-10","ref":"changelog.html#changed"},{"type":"extras","title":"Added - Changelog","doc":"- Clean Zig cache on `mix.clean`.\n- Add functionality to automatically download the `zig` toolchain, also with a specific version.\n- Allow defining the build mode from the Mix configuration.","ref":"changelog.html#added"},{"type":"extras","title":"Changed - Changelog","doc":"- BREAKING: rename `:build_dot_zig_executable` option to `:zig_executable`.\n\n## [0.1.1] - 2023-03-03","ref":"changelog.html#changed"},{"type":"extras","title":"Fixed - Changelog","doc":"- Handle `:default` in the `:build_dot_zig_executable` option.","ref":"changelog.html#fixed"},{"type":"extras","title":"Changed - Changelog","doc":"- Put `zig-cache` in the `_build` folder with all other build artifacts.\n\n## [0.1.0] - 2023-02-26","ref":"changelog.html#changed"},{"type":"extras","title":"Added - Changelog","doc":"- Initial release.","ref":"changelog.html#added"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}